package  
{
	import org.flixel.FlxGroup;
	import org.flixel.FlxPoint;
	import org.flixel.FlxSprite;
	import org.flixel.FlxU;
	import org.flixel.FlxG;
	import org.flixel.plugin.photonstorm.*;
	
	/**
	 * ...
	 * @author Nathan McCoy
	 */
	public class Ember extends FlxSprite 
	{
		public var glowR:int;
		public var glowG:int;
		public var glowB:int;
		public const baseR:int = 60;
		public const baseG:int = 30;
		public const baseB:int = 0;
		public const decay:Number = 0.93;
		
		private var player:PlayerSprite;
		
		private var last_pos:FlxPoint;
		private var curr_pos:FlxPoint;
		
		private var friendList:FlxGroup;
		
		public function Ember(p:PlayerSprite, friends:FlxGroup) 
		{
			super(Math.random() * FlxG.camera.width, Math.random() * FlxG.camera.height);
			friendList = friends;
			player = p;
			makeGraphic(1, 1);
			//blend="add";
			maxVelocity.x = maxVelocity.y = 20;
			velocity.y = 20;
			last_pos = new FlxPoint();
			curr_pos = new FlxPoint();
			last_pos.x = curr_pos.x = x;
			last_pos.y = curr_pos.y = y;	
			//this.setOriginToCorner();
		}
		
		private function resetGlow():void
		{
			glowR = glowG = glowB = 0;
		}
		
		public override function update():void
		{
			//glowR = Math.max(glowR - decay, 0);
			//glowG = Math.max(glowG - decay, 0);
			//glowB = Math.max(glowB - decay, 0);
			glowR *= decay;
			glowG *= decay;
			glowB *= decay;
			
			
			var pvel:Number = Math.sqrt(player.velocity.x ^ 2 + player.velocity.y ^ 2);
			var dist:Number = Math.sqrt((player.x - x) * (player.x - x) + (player.y - y) * (player.y - y));
			var energy:Number = (50*player.energy) / (dist / 10 + 1);
			glowR += energy;
			glowG += energy * 0.7;
			glowB += energy * 0.4;
			
			acceleration.x = Math.random()*160 - 80;
			
			
			var repos:Boolean = false;
			while(x < FlxG.camera.scroll.x)
			{
				x += FlxG.camera.width;
				repos = true;
			}
			while(x > FlxG.camera.scroll.x + FlxG.camera.width)
			{
				x -= FlxG.camera.width;
				repos = true;
			}
			
			while(y < FlxG.camera.scroll.y)
			{
				y += FlxG.camera.height;
				repos = true;
			}
			while(y > FlxG.camera.scroll.y + FlxG.camera.height)
			{
				y -= FlxG.camera.height;
				repos = true;
			}
			if (repos) resetGlow();
			color = FlxU.makeColor(Math.min(glowR + baseR, 255), Math.min(glowG + baseG, 255), Math.min(glowB + baseB, 255), 1.0);
			
			
			last_pos.x = x;
			last_pos.y = y;
			super.update();
			curr_pos.x = x;
			curr_pos.y = y;
			
			
			for (var i:int = 0; i < friendList.length; i++)
			{
				var tcan:Friend = (friendList.members[i] as Friend);
				if (tcan != null && crossedRayTo(new FlxPoint(tcan.x, tcan.y)))
				{
					glowR = Math.max(FlxColor.getRed(tcan.color) * (1-player.energy), glowR);
					glowG = Math.max(FlxColor.getGreen(tcan.color)* (1-player.energy), glowG);
					glowB = Math.max(FlxColor.getBlue(tcan.color)* (1-player.energy), glowB);
				}
			}
		}
		public function crossedRayTo(toward:FlxPoint):Boolean
		{
			//var old_ray:FlxPoint = new FlxPoint(last_pos.x - player.x, last_pos.y - player.y);
			//var new_ray:FlxPoint = new FlxPoint(curr_pos.x - player.x, curr_pos.y - player.y);
			//var old_angle:Number = Math.atan2(old_ray.y, old_ray.x);
			var new_angle:Number = Math.atan2(curr_pos.y - player.y, curr_pos.x - player.x);
			var test_angle:Number = Math.atan2(toward.y - player.y, toward.x - player.x);
			//return (Math.sin(old_angle-test_angle) < 0) != (Math.sin(new_angle-test_angle) < 0);
			return Math.abs(new_angle-test_angle) < 0.03;
		}
	}

}