package  
{
	import org.flixel.FlxDialog;
	import org.flixel.FlxSound;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxG;
	
	
	/**
	 * ...
	 * @author Nathan McCoy
	 */
	public class IntroState extends FlxState 
	{
		internal var introTime:Number = 0;
		internal var totalTime:Number = 0;
		internal var dialog:FlxDialog = new FlxDialog(5, 240 - 77, 310, 72, 0.03);
		[Embed(source = "data/binding.png")] private var ImgBinding:Class;
		[Embed(source = "data/broken.png")] private var ImgBroken:Class;
		
		[Embed(source = "data/pulse1.png")] private var ImgPulse1:Class;
		[Embed(source = "data/pulse2.png")] private var ImgPulse2:Class;
		[Embed(source = "data/pulse3.png")] private var ImgPulse3:Class;
		[Embed(source = "data/pulse4.png")] private var ImgPulse4:Class;
		[Embed(source = "data/Doom1.mp3")] private var SndDoom1:Class;
		[Embed(source = "data/Doom2.mp3")] private var SndDoom2:Class;
		[Embed(source = "data/pulse.mp3")] private var SndPulse:Class;
		
		
		internal var pulse1:FlxSprite;
		internal var pulse2:FlxSprite;
		internal var pulse3:FlxSprite;
		internal var pulse4:FlxSprite;
		internal var binding:FlxSprite;
		internal var broken:FlxSprite;
		internal var dialogState:int = 0;
		internal var doom1:FlxSound = new FlxSound().loadEmbedded(SndDoom1);
		internal var doom2:FlxSound = new FlxSound().loadEmbedded(SndDoom2);
		
		public function IntroState() 
		{
			
			
		 pulse1 = new FlxSprite().loadGraphic(ImgPulse1);
		 pulse2 = new FlxSprite().loadGraphic(ImgPulse2);
		 pulse3 = new FlxSprite().loadGraphic(ImgPulse3);
		 pulse4 = new FlxSprite().loadGraphic(ImgPulse4);
		 binding = new FlxSprite().loadGraphic(ImgBinding);
		 broken  = new FlxSprite().loadGraphic(ImgBroken);
		
			pulse1.blend = "add";
			pulse2.blend = "add";
			pulse3.blend = "add";
			pulse4.blend = "add";
			
			add(pulse1);
			add(pulse2);
			add(pulse3);
			add(pulse4);
			add(binding);
			
			add(dialog);
			
			FlxG.mouse.hide();
			FlxG.playMusic(SndPulse,1);
			
		}
		
		public override function update():void
		{
			super.update();
			totalTime += FlxG.elapsed * 2;
			pulse1.alpha = Math.sin(totalTime)/2+0.75;
			pulse2.alpha = Math.sin(totalTime - Math.PI/2)/2+0.75;
			pulse3.alpha = Math.sin(totalTime - Math.PI)/2+0.75;
			pulse4.alpha = Math.sin(totalTime - Math.PI * 3/2)/2+0.75;
			
			if (!dialog.showing)
			{
				introTime += FlxG.elapsed;	
			}
			if (introTime > 2 && dialogState == 0)
			{
				dialog.showDialog( new Array("< Hang in there, everyone! We just need to keep it confined \nuntil-- >"));
				dialogState++;
			}
			if (introTime > 2.2 && dialogState == 1)
			{
				FlxG.flash(0xff222222, 0.4);
				FlxG.shake(0.01, 0.15);
				doom1.play(true);
				FlxG.music.stop();
				dialog.showDialog( new Array("< No... >"));
				dialogState++;
			}
			if (introTime > 2.4 && dialogState == 2)
			{
				FlxG.flash(0xff222222, 0.4);
				FlxG.shake(0.01, 0.15);
				doom1.play(true);
				dialogState++;
			}
			if (introTime > 2.7 && dialogState == 3)
			{
				FlxG.flash(0xff222222, 0.4, null, true);
				FlxG.shake(0.01, 0.15);
				doom1.play(true);
				dialogState++;
				dialog.showDialog( new Array("< No!! >"));
			}
			
			if (introTime > 3.3 && dialogState == 4)
			{
				FlxG.flash(0xffff0000, 0.6, null, true);
				FlxG.shake(0.01, 0.15);
				doom2.play(true);
				remove(pulse1);
				remove(pulse2);
				remove(pulse3);
				remove(pulse4);
				remove(binding);
				add(broken);				
				dialogState++;
			}
			if (introTime > 5 && dialogState == 5)
			{
				FlxG.fade(0xFF000000, 2);
			}
			if (introTime > 8)
			{
				FlxG.switchState(new PlayState());
			}
			
		}
	}

}