package
{

	import flash.geom.Rectangle;
	import org.flixel.*;
	import org.flixel.plugin.photonstorm.*;

	public class MenuState extends FlxState
	{
		
		private var playButton:FlxButton;
		private var devButton:FlxButton;
		private var Title:FlxText;
		
		[Embed(source = "data/fire.png")] private var Fire:Class;
		[Embed(source = "data/clouds.png")] private var Clouds:Class;
		[Embed(source = "data/embers_mask.png")] private var TitleMask:Class;
		
		private var titleSprite:FlxSprite;
		private var fireSprite:FlxSprite;
		private var smokeSprite:FlxSprite;
		private var compositedSprite:FlxSprite;
		private var scroller:FlxScrollZone;
		
		
		override public function create():void
		{
			titleSprite = new FlxSprite();
			titleSprite.loadGraphic(TitleMask);
			fireSprite = new FlxSprite();
			fireSprite.loadGraphic(Fire);
			smokeSprite = new FlxSprite();
			smokeSprite.loadGraphic(Clouds);
			compositedSprite = new FlxSprite();
			
			add(smokeSprite);
			
			FlxDisplay.alphaMaskFlxSprite(fireSprite, titleSprite, compositedSprite);
			scroller = new FlxScrollZone();
			add(scroller);
			add(compositedSprite);
			FlxScrollZone.add(fireSprite, new Rectangle(0, 0, fireSprite.width, fireSprite.height), 0, -1);
			FlxScrollZone.add(smokeSprite, new Rectangle(0, 0, smokeSprite.width, smokeSprite.height), 0, -0.75);
			
			
			
			
			FlxG.bgColor = 0xff000000;
			
			Title = new FlxText(FlxG.width / 2 - 150, 200, 300, "press X to advance text   use X and arrow keys to fly\nremain motionless to listen");
			Title.alignment = "center";
			Title.color = 0xFFAAAAAA;
			Title.antialiasing = false;
			add(Title);
			
			
			devButton = new FlxButton(FlxG.width/2-40,FlxG.height / 3 + 60, "Insert Site", onSite);
			devButton.soundOver = null;  //replace with mouseOver sound
			devButton.color = 0xff330077;
			devButton.label.color = 0xffFFBB22;
			//add(devButton);
			
			playButton = new FlxButton(FlxG.width/2-40,FlxG.height / 3 + 100, "Click To Play", onPlay);
			playButton.soundOver = devButton.soundOver;
			playButton.color = devButton.color;
			playButton.label.color = devButton.label.color;
			add(playButton);
			
			
			FlxG.mouse.show();
			
		}
		
		override public function update():void
		{
			super.update();	
			FlxDisplay.alphaMaskFlxSprite(fireSprite, titleSprite, compositedSprite);
		}
		
		protected function onSite():void
		{
			
			FlxU.openURL("http://example.com/");  //replace with your site's URL 
		}
		
		protected function onPlay():void
		{
			playButton.exists = false;
			FlxG.switchState(new IntroState());
		}
		
		
	}
}

