package
{

	import org.flixel.*;
	import org.flixel.plugin.photonstorm.*;
	
	public class PlayState extends FlxState
	{
		[Embed(source = "data/automap.png")] private var MapData:Class;
		[Embed(source = "data/auto_tiles2.png")] private var TileSet:Class;
		[Embed(source = "data/twinklestar.png")] private var StarSprite:Class;
		[Embed(source = "data/deadsky.png")] private var DeadSky:Class;
		
		[Embed(source = "data/vanish.mp3")] private var VanishSound:Class;
		[Embed(source = "data/hardhit.mp3")] private var HardSound:Class;
		[Embed(source = "data/softhit.mp3")] private var SoftSound:Class;
		[Embed(source = "data/windy.mp3")] private var WindySound:Class;
		
		
		
		
		var map:FlxTilemap;
		var player:PlayerSprite;
		var embers:FlxGroup;
		var sky:FlxSprite;
		var cam_target:FlxSprite;
		var cam_factor:Number = 0.8;
		
		var quiet_time:Number;
		const MAX_QUIET:Number = 5;
		var game_time:Number = 0;
		var first_message:Boolean = false;
		
		internal var dialog:FlxDialog = new FlxDialog(5, 240 - 77, 310, 72, 0.03);
		
		var friends:FlxGroup;
		
		var vanishing:Friend = null;
		
		var enthusiasm:Number;
		var MAX_ENTHUSIASM:Number = 7.5;
		
		var end_timer:Number;
		
		public function lastsound():void
		{
			FlxG.play(VanishSound);
			FlxG.music.fadeOut(10);
		}
		
		override public function create():void
		{
			sky = new FlxSprite().loadGraphic(DeadSky);
			sky.scrollFactor.x = sky.scrollFactor.y = 0;
			add(sky);
			
			cam_target = new FlxSprite();
			cam_target.visible = false;
			add(cam_target);
			
			map = new FlxTilemap();
			map.loadMap(FlxTilemap.imageToCSV(MapData), TileSet, 16, 16, FlxTilemap.AUTO);
			add(map);
			player = new PlayerSprite();
			player.loadGraphic(StarSprite, true, false, 8, 8);
			player.addAnimation("main", new Array(0, 1, 2, 3, 4, 5, 6, 7), 15, true);
			player.play("main");
			
			add(player);
			FlxG.camera.follow(cam_target);
			
			player.maxVelocity.x = 300;
			player.maxVelocity.y = 300;
			player.acceleration.y = 150;
			player.x = 16*76;
			player.y = 16*12;
			player.elasticity = 0.3;
			map.elasticity = 0.3;
			player.velocity.x = 300;
			player.velocity.y = 300;
			
			FlxG.worldBounds.make(0, 0, map.width, map.height);
			
			friends = new FlxGroup();
			var reg:Friend = new Friend(0xFFd6196f, new Array(
			"< Regulus! Man, am I glad to see you! >",
			"< Yeah, I know... it's all just sort of draining away. >",
			"< What? C'mon, Reg, that's not funny. >",
			"< Of course we can! You're here, I'm here, we can still... >",
			"< What's gotten into you?\n You've never given up on anything! >",
			"< Don't-- don't say things like that! Reg! >",
			"< Reg... Dammit... >")
			, 500, 500);
			friends.add(reg);
			
			var beets:Friend = new Friend(0xFF0268f1, new Array(
			"< Beets! You made it! >",
			"< D... don't what? What else am I supposed to call you? >",
			"< I don't understand... You've always hated that name. >",
			"< Look, I think we can still stop it, seal it closed again.\n But I need everyone's help... >",
			"< Why not? >",
			"< It wasn't anyone's fault. >",
			"< Maybe things could have been different.\n Maybe they still can. >",
			"< Won't you at least try? >")
			,141 * 16, 71 * 16);
			friends.add(beets);
			
			var mira:Friend = new Friend(0xFF94ff00, new Array(
			"< Mira! You're okay! >",
			"< It's me... you know, your friend since forever? >",
			"< Never met... you're kidding, right? >",
			"< Mira, listen, I'm trying to help you.\n Trying to help all of us, trying to undo this mess. >",
			"< Me too. We all are. But we can't just give up. >",
			"< Just stay... We'll get through this, I promise. >",
			"< Please, Mira... >"),
			27 * 16, 73 * 16);
			friends.add(mira);
			
			
			var proce:Friend = new Friend(0xFF00ffe4, new Array(
			"< Hey, Proce! >",
			"< Ouch, dude. That was kinda uncalled for. >",
			"< I was there! I was right next to you! >",
			"< Look, I know we're all pretty stressed, but-- >",
			"< I don't know, maybe it wasn't aligned right\n or something... We need to figure out-- >",
			"< Dude, chill out. If you keep that up you'll... >"),
			87 * 16, 55 * 16);
			friends.add(proce);
			
			var rigel:Friend = new Friend(0xFFff4700, new Array(
			"< Rigel! >",
			"< Hey, Rigel! >",
			"< Hello? Can you hear me? >",
			"< Can you even see me? >",
			"< No, don't! It's broken now, you won't be able to-- >"),
			162 * 16, 37 * 16);
			friends.add(rigel);
			
			var vega:Friend = new Friend(0xFFf5bd00, new Array(
			"< Vega! There you are! >",
			"< Not sure about what? >",
			"< Well, we need to keep trying, don't we? >",
			"< Aren't you the one always telling us to stick together? >",
			"< Look, we need to stay focused, or we'll all run out of... >"),
			73 * 16, 79 * 16);
			friends.add(vega);
			add(friends);
			
			embers = new FlxGroup();
			var i:int;
			
			for (i = 0; i < 400; i++)
			{
			 	embers.add(new Ember(player, friends));
			}
			add(embers);
			cam_target.x = player.x;
			cam_target.y = player.y;
			FlxG.music.destroy();
			FlxG.camera.setBounds(16, 16, map.width - 32, map.height - 32);
			
			quiet_time = 0;
			add(dialog);
			
			FlxG.playMusic(WindySound, 0.5);
			FlxG.flash(0xFF000000);
			
			enthusiasm = MAX_ENTHUSIASM;
			end_timer = 0;
		}
		
		public function endGame():void
		{
			//dialog.showDialog(new Array("< Man, I'm just... exhausted. >", 
			//"< Maybe I could just take a nap... >", 
			//"< I'll figure things out... later... >"));
			enthusiasm = 0;
		}
		
		override public function update():void
		{
			if (!dialog.showing)
			{
				
			if (enthusiasm == 0)
			{
				if (end_timer == 0)
					FlxG.fade(0xFF000000, 10, lastsound);
				end_timer += FlxG.elapsed;
			}
				
			super.update();
			FlxG.collide(player, map, bounce);
			FlxG.collide(friends, map);
			
			var steer:Number = 0;
			if (FlxG.keys.pressed("LEFT")) steer -= 1;
			if (FlxG.keys.pressed("RIGHT")) steer += 1;
			if (FlxG.keys.justPressed("X")) 
			{
				//player.velocity.y *= 0.7;
								
				player.velocity.y -= 100 * enthusiasm/MAX_ENTHUSIASM;
				player.velocity.x += 100 * steer * enthusiasm/MAX_ENTHUSIASM;
				
			}
			player.acceleration.x = steer * 200 * enthusiasm/MAX_ENTHUSIASM;
				player.drag.x = 60;
				
				cam_target.x = cam_target.x * cam_factor + player.x * (1 - cam_factor);
				cam_target.y = cam_target.y * cam_factor + player.y * (1 - cam_factor);
				
			//player.acceleration.x = steer * 600;
			//player.drag.x = 100;
			
			if (Math.abs(player.velocity.x) < 10 && Math.abs(player.velocity.y) < 10) quiet_time += FlxG.elapsed;
			else quiet_time = 0;
			if (quiet_time < 0) quiet_time = 0;
			if (quiet_time > MAX_QUIET) 
			{
				quiet_time = MAX_QUIET;
				player.listening = true;
				if (friends.length == 0 && enthusiasm != 0)
				endGame();
			}
			else player.listening = false;
			player.energy = 1 - quiet_time / MAX_QUIET;
			
			
			game_time += FlxG.elapsed;
			
			if (game_time > 3 && !first_message)
			{
				first_message = true;
				dialog.showDialog(new Array( 
				"< Ow... >", 
				"< What... what happened? It... >", 
				"< It broke through... >", 
				"< We've got to get back there and stop it! >", 
				"< Guys? Guys, can you hear me? Are you out there? >"));
			}
			
			if (vanishing != null)
			{
				FlxG.flash(vanishing.color);
				friends.remove(vanishing,true);
				FlxG.play(VanishSound);
				vanishing = null;
				enthusiasm--;
				var shade:Number = enthusiasm / MAX_ENTHUSIASM * 0.5 + 0.5;
				sky.color = FlxColor.getColor24(shade * 255, shade * 255, shade * 255);
			}
			
			FlxG.overlap(player, friends, touchFriend);
			
			}
			else { dialog.update();}
		}
		function touchFriend(o1:FlxObject, o2:FlxObject):void
		{
			var friend:Friend = o2 as Friend;
			dialog.showDialog(friend.text);
			vanishing = friend;
		}
		function bounce(o1:FlxObject, o2:FlxObject):void
		{
			//if (FlxMath.vectorLength(player.velocity.x, player.velocity.y) > 100) FlxG.play(HardSound);
			//else if (FlxMath.vectorLength(player.velocity.x, player.velocity.y) > 20) FlxG.play(SoftSound);
		}
	}
	
}

